//
//  Convert2Gray.cpp
//  Convert2Gray
//
//  Created by Legum on 01/02/2016.
//
//

#include "Convert2Gray.h"

namespace sparse_filter {
	void Convert2Gray(const Image& source, Image *output) {
		
		output->Init(source.rows(), source.columns(), 1);
		output->Reset();
		
		for (int row=0; row<source.rows(); ++row) {
			for (int col=0; col<source.columns() ; ++col) {
				output->val(col,row) = 0.f;
				for (int chan=0; chan<source.channels(); ++chan) {
					output->val(col,row) += source.val(col, row, chan);
				}
				output->val(col,row) /= source.channels();
			}
		}
	}
}
