#ifndef SPARSEFILTER_H
#define SPARSEFILTER_H

namespace sparse_filter {
    class Image;

    void SparseFilter(      const Image& source, float sigma_d2, float sigma_r2, int r,
                            float threshold, Image* output);

    void BilateralFilter(   const Image& source, float sigma_d2, float sigma_r2, int r, Image* output);

    void BilateralFilterReg(const Image& source, float sigma_d2, float sigma_r2, int r, Image* output);

    void SBFR(              const Image& source, float sigma_d2, float sigma_r2, int r, float threshold, Image* output, Image* computedpx);

	void SBFR2(				const Image& source, float sigma_d2, float sigma_r2, int r, float threshold, Image* output, Image* computedpx);
	
	void ComputeDiff(const Image& source, const Image& output, Image *difference);
	
}  // namespace sparse_filter

#endif /* end of include guard: SPARSEFILTER_H */
