function FastLocalLaplacian(scr_col_name,source_name,sigR,factor,NbSlices)

source = double(imread(source_name))/255;

sig_r  = str2double(sigR)/255;
fact   = str2double(factor);
N      = str2double(NbSlices);

output = llf(source,sig_r,fact,N);

imwrite(uint8(255*output),'locallaplacian_base.png');
imwrite(uint8(255*(.5 + source - output)),'locallaplacian_detail.png');

% Apply lighting
LUTfile_id      = fopen('input_2','r');
doplut          = NaN(32768,1);
for n=1:32768
    doplut(n)   = str2double(fgetl(LUTfile_id));
end
fclose(LUTfile_id);

gain_det = max(0,(source + .6*(source - output))./source); % max avoids NaN
gain_uco = max(0,(source +3.6*(source - output))./source); % max avoids NaN
gain_lum = max(0,(doplut( max(1,min(32768,round(output*(2^15-1) +1))) )/(2^15 -1))./output );

src_col  = double(imread(scr_col_name));
lighting = zeros(size(src_col));
ucontrast = zeros(size(src_col));

lighting(:,:,1) = src_col(:,:,1).*gain_det.*gain_lum;
lighting(:,:,2) = src_col(:,:,2).*gain_det.*gain_lum;
lighting(:,:,3) = src_col(:,:,3).*gain_det.*gain_lum;

imwrite(uint8(lighting),'locallaplacian_lighting.png');

ucontrast(:,:,1) = src_col(:,:,1).*gain_uco.*gain_lum;
ucontrast(:,:,2) = src_col(:,:,2).*gain_uco.*gain_lum;
ucontrast(:,:,3) = src_col(:,:,3).*gain_uco.*gain_lum;

imwrite(uint8(ucontrast),'locallaplacian_lighting_ucontrast.png');

end