function output = IterativeGuidedFilter_clean(input,sig_s,epsilon,r)
% Help here
% output = IterativeGuidedFilter(input,sig_s,epsilon,r)
% 
% Tuesday 23, February 2016 -- C. Hessel

ker = ones(1,2*r+1)/(2*r+1);

I_mean = conv2(mirror(...
         conv2(mirror(input   ,[r,0]),ker','valid'),[0,r]),ker,'valid');
I_var  = conv2(mirror(...
         conv2(mirror(input.^2,[r,0]),ker','valid'),[0,r]),ker,'valid')...
         - I_mean.^2;

a = 1 - exp( -I_var ./ (2*epsilon) );
% a = I_var ./ ( I_var + epsilon );
b = (1 - a).*I_mean;

a_mean = conv2(mirror(...
         conv2(mirror(a,[r,0]),ker','valid'),[0,r]),ker,'valid');
     
b_mean = conv2(mirror(...
         conv2(mirror(b,[r,0]),ker','valid'),[0,r]),ker,'valid');
     
output = a_mean.*input + b_mean;

cpt = 1;
sig_s_equ = sqrt(((2*r +1)^2 -1)/6);
fprintf('*');

while( sig_s_equ < sig_s )
    
    output_mean = conv2(mirror(...
                  conv2(mirror(...
                  output,[r,0]),ker','valid'),[0,r]),ker,'valid');
    
    b      = (1 - a).*output_mean;
    b_mean = conv2(mirror(...
             conv2(mirror(b,[r,0]),ker','valid'),[0,r]),ker,'valid');
    
    output = a_mean.*input + b_mean;
    
    
    cpt = cpt +1;
    sig_s_equ = sqrt(cpt*((2*r +1)^2 -1)/6);
    
    fprintf('*');
    if mod(cpt,10) == 0, fprintf(' '); end;
    if mod(cpt,50) == 0, fprintf('\n'); end;
end
fprintf('\nTotal: %d Iterations\n',cpt);
end