function output = PyramidalGuidedFilter_clean(I, epsilon, n_levels)

input_gaussian_pyr  = gaussian_pyramid( I    ,n_levels);
input2_gaussian_pyr = gaussian_pyramid( I.^2 ,n_levels);
output_laplace_pyr  = laplacian_pyramid(I    ,n_levels);

% start with low pass residual
output = output_laplace_pyr{n_levels};
filter = pyramid_filter;

for lev = n_levels-1 : -1 : 1
    
    odd = 2*size(output) - size(output_laplace_pyr{lev});
    
    % upsample, and add to current level
    V = upsample(input2_gaussian_pyr{lev+1},odd,filter) ...
        - upsample(input_gaussian_pyr{lev+1},odd,filter).^2;
    
    output = output_laplace_pyr{lev}.*(1 - exp(-V/(2*epsilon))) ...
        + upsample(output,odd,filter);
    
%     output = output_laplace_pyr{lev}.*( V ./( V + epsilon )) ...
%         + upsample(output,odd,filter);
end

end