function filtered = SelectiveDiffusion(source,filtered,NbIt)

    % /// Fixed parameters ///
    sigma  = 2;
    lambda = sqrt(2);
    nu     = 0.20;
    % ///
    
    for k=1:NbIt

        radius = ceil(2*sigma);
        gauss  = exp(-.5*(-radius:radius).^2/sigma^2);
        gauss  = gauss./sum(gauss);

        radius2 = ceil(2*sigma*nu);
        gauss2  = exp(-.5*(-radius2:radius2).^2/(sigma*nu)^2);
        gauss2  = gauss2./sum(gauss2);

        % /// D est D_{i-1}
        filtblurred  = conv2(mirror(filtered,[0,radius]),gauss ,'valid');
        filtblurred  = conv2(mirror(filtblurred,[radius,0]),gauss','valid');

        Eb = (filtblurred-source).^2;
        Eb = conv2(mirror(Eb,[0,radius2]),gauss2 ,'valid');
        Eb = conv2(mirror(Eb,[radius2,0]),gauss2','valid');

        Eu = (filtered-source).^2;
        Eu = conv2(mirror(Eu,[0,radius2]),gauss2 ,'valid');
        Eu = conv2(mirror(Eu,[radius2,0]),gauss2','valid');
        
        alpha = max(0,min(1, 2*(Eb./Eu -.5)));

        filtered = alpha.*filtered + (1-alpha).*filtblurred;

        % /// Update sigma
        sigma = sigma*lambda;
    end
end